#!/usr/bin/python
import numpy as np
import matplotlib.pyplot as plt
import os
import sys
from shutil import copy2, copyfile
import subprocess as sb

yrAstart=1./12.
yrBstart=yrAstart+0.5

#yrAmid=0.5*(yrBstart+yrAstart)
#yrBmid=yrAmid+0.5



def getData(fileName,idx):
    fin = open(fileName,'r')
    dataNow=[]
    dataRV=[]
    dataAstro=[]
    fin.readline()
    
    for l in fin:
        ls=l.split()
        if (len(ls)>1):
            
            if ls[2]=='None':
                dataNow.append([int(ls[0]), float(ls[3]) , float(ls[idx+4]) ])
            elif ls[2]=='rv':
                dataRV.append([int(ls[0]), float(ls[3]) , float(ls[idx+4]) ])
            elif ls[2]=='astro':
                dataAstro.append([int(ls[0]), float(ls[3]) , float(ls[idx+4]) ])
            else:
                print 'Error'

    return np.array(dataNow),np.array(dataAstro),np.array(dataRV)



idx=9
if len (sys.argv)==2:
    inputFile=sys.argv[1]
elif len (sys.argv)==3:
    inputFile=sys.argv[1]
    idx=int(sys.argv[2])

else:
    inputFile='2stars.dat'
print 'Input file: ', inputFile

datNow,datAstro,datRV = getData(inputFile,idx)



print datNow,datAstro,datRV

plt.plot(datNow[:,0],datNow[:,1],'o')
plt.plot(datRV[:,0],datRV[:,1],'o')
plt.plot(datAstro[:,0],datAstro[:,1],'x')
plt.xlabel('Iteration')
plt.ylabel('Date of observations')

plt.gca().get_yaxis().set_major_formatter(plt.FormatStrFormatter('%.1f'))

plt.savefig(inputFile.split('.')[0]+'_date.png',transparent=False)

fac=1
if idx==12:
    fac=365.25

plt.figure()
plt.plot(datNow[:,0],fac*datNow[:,2],'o')
plt.plot(datRV[:,0],fac*datRV[:,2],'o')
plt.plot(datAstro[:,0],fac*datAstro[:,2],'x')
plt.xlabel('Iteration')
plt.ylabel('Uncertainty')

#plt.gca().get_yaxis().set_major_formatter(plt.FormatStrFormatter('%.1f'))

plt.savefig(inputFile.split('.')[0]+'_uncertainty.png',transparent=False)
