#!/usr/bin/python
import numpy as np
import matplotlib.pyplot as plt
import os
import sys


Nmiss=6


def getData(fileName,idx):
    fin = open(fileName,'r')
    dat=[]
    idx = 9
    
    datN = [[]]
    for i in range(Nmiss):
        datN.append([])

    
    for l in fin:
        ls=l.split()
        
        date=np.array([float(ls[12]), float(ls[14]), float(ls[16]), float(ls[18]), float(ls[20]), float(ls[22])])
        #print date
        
        n2018=len(np.where(date>2018.)[0])
        
        dat.append([int(ls[0]), float(ls[idx]), n2018, ls.count('R')])
        datN[n2018].append(float(ls[idx]))

    return np.array(dat),datN



idx=9
if len (sys.argv)==2:
    inputFile=sys.argv[1]

else:
    inputFile='weather1/2stars.wea'
print 'Input file: ', inputFile

dat,datN= getData(inputFile,idx)

print np.where(dat[:,1]>0.2)
print 'Number of obs. with SNR < 5 :', len(np.where(dat[:,1]>0.2)[0]), ' out of ', len(dat[:,1])
print 'i.e. relative number ',len(np.where(dat[:,1]>0.2)[0])/(1.*len(dat[:,1]))

plt.plot(dat[:,2],1./dat[:,1],'o')
plt.xlabel('Number of missing obs in 2018')
plt.ylabel('Redshift SNR')
plt.xlim([-0.5, 6.5])

#plt.gca().get_yaxis().set_major_formatter(plt.FormatStrFormatter('%.1f'))

plt.savefig(inputFile.split('.')[0]+'_weather.png',transparent=False)

plt.figure()
plt.hist(1./dat[:,1],bins=np.arange(1.,7.5,0.25))
#plt.gca().get_yaxis().set_major_formatter(plt.FormatStrFormatter('%.1f'))
plt.xlabel('Redshift SNR')
plt.savefig(inputFile.split('.')[0]+'_weather_hist.png',transparent=False)


plt.figure()
for i in range(Nmiss+1):
    plt.subplot(4,2,i+1)
    plt.hist(1./np.array(datN[i]),bins=np.arange(1.,7.5,0.25))
    plt.legend([str(i)+' obs. missing in 2018'],loc='best')
    plt.xlabel('Redshift SNR')
plt.savefig(inputFile.split('.')[0]+'_weather_subhist.png',transparent=False)
plt.show()