import numpy as np
#from matplotlib import pyplot as plt
import os.path
import sys
import covariance_analysis as cov
sys.path.append('/u/arezu/Documents/GCG/GRtests/confusion/')
from constants import tosort_inverted, stop, tosort

#---------------------------------------------------------------------------------------------

def get_information_from_common_signature(instances, tDir, common_sig):
	'''
	I have to read two files: first the usedstars
	'''
	
	inst = [inst for inst in instances if (inst.signature==common_sig)]
	if len(inst)==0:
		stop('you dont have your reference input for %s' %common_sig)
	inst=inst[0]

	# get years and parcolnum and parcolnames
	parcol = [inst.globparnames.index(g) for g in inst.globparnames if g in inst.par2testlist]
	partestnames = [g for g in inst.globparnames if g in inst.par2testlist]
	partestidx = [i for i,g in enumerate(inst.globparnames) if g in inst.par2testlist]
	years=np.genfromtxt(inst.senall_address, dtype='str')[:,0].astype(float)
	totstars=inst.stars_names


	# 1read usedstars
	used=[]
	nused=[]
	inf = open(tDir+inst.usedstars, 'r')
	lines = list(line for line in (lines.strip() for lines in inf) if line) # NO EMPTY LINE
	inf.close()
	for line in lines:
		used.append(line.split()[2:-1])
		nused.append(int(line.split()[-1]))

	neverused = [s for s in totstars if s not in used[-1]]

	# 2 check if everything is run
	for item in instances:
		if len(np.genfromtxt(item.senall_address, comments='#'))!=len(years):
			stop('you should rerun this file %s ' %item.name)
	
	return used, nused, parcol,partestnames,years,totstars, neverused, partestidx

def make_selected_best_stars():
	'''
	get the bests
	'''
	

def get_ranking_single(instances, stars, used_stars, nstars, cols, parnames, yrs,prefix,outdir, paramidx, rankingmode):
	'''
	for each input for test category
	stars: a list of lists for years
	nstars: a list of nstars for years
	'''


	#rename signatures
	#these signatures become the first column	
	rankmode = rankingmode[0]
	selectmode = rankingmode[1]##self.select_bests_mode = [True, 'OK', 5.,[1,5,10,20]]#[used?, which_measurements?, how_many_last_years?, how_many_best_stars?]
	parvarymode = rankingmode[2]

	refname='tot'
	#starnames = []
	#for item in used_stars:
	#	[starnames.append(bla) for bla in item]
	starnames = [bla.name for bla in stars]
	
	obj2rank = [bla for bla in instances if bla.signature.replace('one','').replace('no','') in starnames+[refname]]
	
	obj_rest = [bla for bla in instances if (bla not in obj2rank or refname in bla.signature)]#it seems this list is not really used
	
	if selectmode[0]:
		last_bests=[[] for item in selectmode[3]]
		first_bests=[[] for item in selectmode[3]]
		all_bests=[[] for item in selectmode[3]]
	
	
	
	uncertcol=[None]*len(obj2rank)#all one tests, different number of stars
	#fill uncert table
	for j,inst in enumerate(obj2rank):
		try:
			file = np.genfromtxt(inst.senall_address, dtype='str')#just because if there are any NaN then it makes them -1. #this is not an issue at the moment. If there is something serious, you need to check the Fortran code.
		except:
			stop('file seems to be empty %s' %inst.name)
		uncertcol[j] = [file[:,2+m].astype(float) for m in cols]#columns
		
	#all the names	
	signatures =  [hazaa.signature.replace('no','').replace('one','') for hazaa in obj2rank]
	
	for i,p in enumerate(parnames):
		allidx=[]
		all_frac_uncert=[]
		uncert=[]


		for j,yr in enumerate(yrs):
			#get the rankings
			# get a unitless fractions. this fraction tot/u. This means the stronget the star, the bigger this number.
		
			tmp=[uncertcol[k][i][j] for k,m in enumerate(obj2rank)]		#this is the uncert column of the param[i]
			sig_in = [sin for qq,sin in enumerate(signatures) if  tmp[qq] >0. and refname not in sin]
			
			totu=tmp[signatures.index(refname)]

			if rankmode[0] and 'drop1' in rankmode[1]:
				_,rankedsig=tosort_inverted(tmp,signatures)#the higher the uncertainty of drop1, the higher the ranking. Since the impct of the dropped star is higher.
			elif (rankmode[0] and 'single' in rankmode[1]) or (parvarymode[0]):
				_,rankedsig=tosort(tmp,signatures)#the higher the uncertainty of single, the lower the ranking.
				#but you have to deal with zero and -1. because they would become the higest ranking now
			else:
				stop('something is wrong with your ranking tests')
				
				
			idx=[rankedsig.index(s)+1 if s in sig_in else -5 if refname in s else -1 for s in signatures]#there is a +1 here so that the ranking starts from one instead of zero
			
			haza= list(np.sort([bla for bla in idx if bla>0.]))#to sort it out nicely. because with 'single' the zeros and negative ones are the smallest
			idx=[haza.index(bla)+1 if bla>0. else -5 if bla==-5 else -1 for bla in idx]

			allidx.append(idx)
			uncert.append(tmp)

			if rankmode[1]=='drop1':
				if totu==0.:
					all_frac_uncert.append([-1.]*len(tmp))
				else:
					all_frac_uncert.append(tmp/totu)
			
			## select the best ones --------------#######
			#selectmode=[True, ['OK','biased','OKbiased'], 5.,[1,5,10,20]]
			
			#last
			if selectmode[0] and rankmode[1]=='single' and yr>=(yrs[-1]-selectmode[2]):
				for jj,item in enumerate(selectmode[3]):#number of best stars/best ranked
					last_bests[jj].append([signatures[kk] for kk,bla in enumerate(idx) if bla<=item and bla>0])
			#first
			if selectmode[0] and rankmode[1]=='single' and yr<=(yrs[0]+selectmode[2]):
				for jj,item in enumerate(selectmode[3]):#number of best stars/best ranked
					first_bests[jj].append([signatures[kk] for kk,bla in enumerate(idx) if bla<=item and bla>0])						

			#all
			if selectmode[0] and rankmode[1]=='single':
				for jj,item in enumerate(selectmode[3]):#number of best stars/best ranked
					all_bests[jj].append([signatures[kk] for kk,bla in enumerate(idx) if bla<=item and bla>0])

		#change dimension of the list and write it up
		if selectmode[0] and rankmode[1]=='single':
			best_file = open(outdir+p+'_'+prefix+'_bests.dat','w')
			best_file.write('# best stars in the first/last 5 years of the analysis based on the "single" ranking mode \n')			
			
			for item,best in zip(selectmode[3],first_bests):
				tmp=[]
				for bt in best:
					for bb in bt:
						tmp.append(bb)	
				best=list(set(tmp))
				best_file.write('first_best_rank_'+str(item)+'_stars \t'+str(len(best))+'\t'+'\t'.join(best)+'\n')

			for item,best in zip(selectmode[3],last_bests):
				tmp=[]
				for bt in best:
					for bb in bt:
						tmp.append(bb)	
				best=list(set(tmp))
				best_file.write('last_best_rank_'+str(item)+'_stars \t'+str(len(best))+'\t'+'\t'.join(best)+'\n')

			for item,best in zip(selectmode[3],all_bests):
				tmp=[]
				for bt in best:
					for bb in bt:
						tmp.append(bb)	
				best=list(set(tmp))
				best_file.write('all_best_rank_'+str(item)+'_stars \t'+str(len(best))+'\t'+'\t'.join(best)+'\n')


			best_file.close()
				


		#rank
		idxtable= np.column_stack((signatures,np.transpose(allidx).astype(int)))#indices table
		filename =outdir+p+'_'+prefix+'_ranking.dat'
		np.savetxt(filename ,idxtable, delimiter='\t', fmt='%s')

		# ufrac
		if 'drop1' in rankmode[1]:
			ufractable= np.column_stack((signatures,np.transpose(all_frac_uncert)))#frac_uncert #techically this does not mean anything unless you have total
			filename =outdir+p+'_'+prefix+'_ufrac.dat'
			np.savetxt(filename ,ufractable, delimiter='\t', fmt='%s')
		# uncert_ranked
		uncerttable= np.column_stack((signatures,np.transpose(uncert)))#frac_uncert
		filename =outdir+p+'_'+prefix+'_uncert.dat'
		np.savetxt(filename ,uncerttable, delimiter='\t', fmt='%s')
		
	return


def get_ranking(alltests, outdir, testDir, ranking_mode, stars_obj):
	'''
	make ranking
	not the most ideal way of writing this file
	'''
	print '--- Writing ranking of each of the stars for different tests ...'
	#testnames=list(set([m.testname for m in alltests]))#
	prefixnames=list(set([m.prefix for m in alltests]))#basically testname ...

	testcat=[None]*len(prefixnames)		#for fixed and not fixed BH	#lolll apparently I didnt use this



	for i,cat in enumerate(testcat):#for different tests: eg: GR or ExtM
		cat	 =[m for m in alltests if (m.prefix==prefixnames[i])]#tests with one prefix
		used_stars, nstars,parcol, partestnames, yrs, tots, neverused, paridx = get_information_from_common_signature(cat, testDir,'tot')
		for c in cat:
			c.neverused=neverused#updating the object
		get_ranking_single(cat, stars_obj, used_stars, nstars, parcol,partestnames, yrs,prefixnames[i],outdir, paridx, ranking_mode)





	return	
	
	
	

#---------------------------------------------------------------------------------------------
