import sys
import itertools as it
import os
import subprocess as sb
import glob
from shutil import copyfile
import pickle
## confusionDir
sys.path.append('/u/arezu/Documents/GCG/GRtests/confusion/')
from constants import sort_by_mag,	createDir,stop	, cov_input_information					#confusionDir
import create_fisher_files
## cadenceDir
sys.path.append('/u/arezu/Documents/GCG/GRtests/cadence_tool/')
from pysrc.covariance_analysis import covariance_analysis			#cadDir
from pysrc import plots												#cadDir
from pysrc import make_files										#cadDir


# currentDir
from locsrc.confusion_inputs import pathes as df			#currentDir
from locsrc.confusion_inputs import dsc			#currentDir
from locsrc.confusion_inputs import mo			#currentDir
#from locsrc.confusion_main import thestarslist

#--------------------------------------
## Input files and directories:
currentDir= os.getcwd()+'/'			#  so I copy paste less :D
currentDir= str.replace(currentDir, 'Network/Servers/galaxy1.astro.ucla.edu/volume1/GhezGroup/home-directories','u')		# technically df knows the currentDir
###	important:: currentDir must be the same as the df.outdir_res 

'''
STEP ZERO :: copy run.py into the directory
STEP One
run the GR tests
'''

print '------------------------------------------------------------------------------------------------------------------'
print '--------------------------------------------------- STARTING the ANALYSIS ----------------------------------------'
print '------------------------------------------------------------------------------------------------------------------'

if currentDir != df.outdir_res:#give a warning
	print '--- WARNING :: You are not running on current Dir (%s)' % (currentDir)
	print '------- ------ the results Dir here is: %s' % (df.outdir_res)
	stop()
	

cov_tests_obj =[]
input_files = glob.glob(df.covinputsdir_res+'*.in')
print '--- the input directory: ', df.covinputsdir_res
print '--- number of input files: ', len(input_files)
for infile in input_files:
	cov_test = covariance_analysis(inputfile=infile, nextMparams=2, outdir=df.locoutputdir_res)#IDEA: in each folder: tests and the fitted parameters are the same! this is important
	#sb.call([ df.fortran_sensitivity_exe , infile])		
	#cov_test.read_sen_file(cov_test.sen_address)
	cov_tests_obj.append(cov_test)

[c.read_sen_all_file() for c in cov_tests_obj]#just to check if they are all finished

#--------------------------
'''
# step 2 : Stars!			read orbital parameters, ages, magnitudes and ... from files (orb or sim)
you might need to update the *args and **kwargs that go into read_stars(). In it became necessary, check main.py in confusion
'''
print '--- We are using pickled telescopes and stars that are stored here:', df.locsrc_res
telescopes_obj = pickle.load( open(df.tels_pickle_filename,'rb'))
thestarslist = pickle.load( open(df.stars_pickle_filename,'rb'))
stardict = pickle.load( open(df.stardict_pickle_filename,'rb'))
cov_obj = pickle.load( open(df.covinfo_pickle_filename,'rb'))


#--------------------------


#--------------------------------------------------------------------------------------------------------
'''
STEP THREE
files and plots
'''
createDir(df.locoutputdir_res)
createDir(df.plotsdir_res)
createDir(df.ranking_outdir_res)
createDir(df.plotsdir_ranking_res)
createDir(df.plotsdir_parvar_res)

if (mo.ranking_mode[0] and  mo.ranking_mode[1] in ['single','drop1']) or (mo.rank_test_vary_param[0]):#drop1 or single
	make_files.get_ranking(cov_tests_obj, df.ranking_outdir_res, df.outdir_res, [mo.ranking_mode,mo.select_bests_mode, mo.rank_test_vary_param],thestarslist)
	plots.plot_ranking_ufrac_uncert(cov_tests_obj, df.plotsdir_ranking_res, thestarslist, stardict, df.ranking_outdir_res, df.locoutputdir_res+df.orbit_closest_furthest_files[0]+'.dat',mo.ranking_mode)


#selected bests
if mo.select_bests_mode[0]:
	#there is one difference between the arguments of this and the one in the /confsion/main.py #be careful if you change it in main.py, you need to change it here too
	create_fisher_files.stars_cov_inputs(thestarslist, theresdir=df.outdir_res, thecovinputDir_src=df.covinsrc, \
						out_thecovinputsDir=df.covinputsdir_res, \
						datadirectory=df.datadir_res, __points_fileformat=df.points_fileformat,__RV_fileformat=df.RV_fileformat, \
						rankmode=mo.ranking_mode, selectmode= [mo.select_bests_mode, df.ranking_outdir_res,df.significance_tot], locoutdir=df.locoutputdir_res, \
						filestatname=df.nopoints_noRV_file, \
						sentime=[cov_obj.last_observed, cov_obj.last_sen_epo, mo.sensitivity_increment], par_vary_mode=mo.rank_test_vary_param,from_ranking=True  )#ok/biased is hardcoded


						

	input_best_rank = glob.glob(df.covinputsdir_res+'*best_rank*.in')
	print '--- the input directory: ', df.covinputsdir_res
	print '--- number of input files: ', len(input_best_rank)
	for infile in input_best_rank:
		cov_test = covariance_analysis(inputfile=infile, nextMparams=2, outdir=df.locoutputdir_res)#IDEA: in each folder: tests and the fitted parameters are the same! this is important
		sb.call([ df.fortran_sensitivity_exe , infile])		
		#cov_test.read_sen_file(cov_test.sen_address)
		cov_tests_obj.append(cov_test)

	[c.read_sen_all_file() for c in cov_tests_obj]#just to check if they are all finished



#if mo.rank_test_vary_param:#wrong i think. there is a jupyter in cadence_tool
#	plots.plot_ranking_varying_params(cov_tests_obj, thestarslist, stardict, df.ranking_outdir_res, df.plotsdir_ranking_res, currentDir)
	

##### old ... they probably need edits
#plots.plot_covarage_and_such(thestarslist, df.locoutputdir_res, df.plotsdir_res, lastobs=2022. )
#plots.plot_ranking_covarage(cov_tests_obj, df.plotsdir_res, currentDir, stardict)

#plots.plot_param_sen(cov_tests_obj, df.plotsdir_res, currentDir)#probably outdated


#plots.plot_period_data(df.plotsdir_res, currentDir)
#plots.plot_measurable_rates(cov_tests_obj,  thestarslist, df.plotsdir_res, stardict, currentDir, timeslice=2019.)	#plot param vs param




print '------------------------------------------------------------------------------------------------------------------'
print '--------------------------------------------------- ANALYSIS ENDS ------------------------------------------------'
print '------------------------------------------------------------------------------------------------------------------'




