program test
	use kindtype
	use starsMod, only: nstars,star,stars
	use constantsMod, only: dirout, nparam
	use dynamicMod, only : initDyn,addparam!,writeSimulated,writeOut
	use modelinterface, only: computepartials
	implicit none
	CHARACTER(LEN=100)           :: nameT
	CHARACTER(LEN=100)           :: nameIn,inputDyn
	CHARACTER(LEN=50)           :: nameOut
	character(len=3) :: num
	character(len=4) :: tmp0,tmp1,tmp2
	character(len=15) :: epsS
	integer :: par
	integer(id)                  :: i
	real(rd) :: eps
	integer :: nv, nbarg,stat,ns
	logical :: exist
	type(star), dimension(:), allocatable :: sinit,splus,sminus
	 
	nbarg = iargc()
	if ((nbarg==1).or.(nbarg==2)) then !if argument when calling this program, use the argument as the constants file name
		CALL getarg(1,namein)
	else 
		WRITE(*,*) 'XXX - ERRROR Only one or two arguments are allowed'
		STOP
	end if
	 
	 
	!Reading the file
	inquire(file=nameIn, EXIST=exist) 
	if (.NOT.exist) then
		WRITE(*,*) "ERROR : File ", trim(nameIn)," does not exist in program testDyn"
		STOP
	endif
	open(unit=55,file=nameIn)
	read(55,'(A)') inputDyn
	read(55,'(A)') nameOut
	read(55,*) par
	read(55,*) eps
	close(55)
		
	!just type
	if (par<10) then
		write(num,'(i1)')par
	else if (par<100) then
		write(num,'(i2)')par
	else if (par<100) then
		write(num,'(i3)')par
	else
		write(*,*) ' XXXX - ERROR when converting par to integer: par>1000'
		stop
	end if
	 

	 
	write(*,*) ' ============================================ '
	write(*,*) ' =======  TEST OF PARTIAL DERIVATIVES ======='
	write(*,*) ' ============================================ '
	write(*,*) ' Parameter considerd: ',par
	write(*,*) ' Epsilon for the numerical derivative: ',eps
	 
	!EVALUATION for the input parameters
	CALL  initDyn(inputDyn)
	
	if (par<0) then
		write(*,*) 'XXXX - ERROR in testDyn: index of parameter <0: ',par
		stop
	end if 
	if (par>nparam) then
		write(*,*) 'XXXX - ERROR in testDyn: index of parameter > nparm (too large): ',par,nparam
		stop
	end if
	
	allocate(sinit(nstars),splus(nstars),sminus(nstars))
	call computePartials()
	sinit=stars
	
	!EVALUATION for par+eps
	CALL  initDyn(inputDyn)
	call addParam(par,eps)
	call computePartials()	 
	splus=stars
	
	!EVALUATION for par-eps
	CALL initDyn(inputDyn)
	call addParam(par,-eps)
	call computePartials()
	
	sminus=stars
	call writeTest

	 
	contains
	subroutine writeTest()
		use constantsMod
		integer(id) :: i,j
		
		do while (par>nparamLoc+nparamglob) 
			par=par-nparamloc
		end do
		
		! PRINT SIMULATED DATA
		do i=1,nstars
			if (sinit(i)%astrob) then
				open(unit=60,file=trim(dirout)//'/'//trim(name)//'_'//trim(sinit(i)%name)//'_tpd_'//trim(num)//trim(extang)//'_tpd',&
					&action='write',status='replace')
				do j=1,sinit(i)%na		!time,	dra/dp,	ddec/dp,	
					write(60,*) sinit(i)%tastro(j),sinit(i)%dradp(j,par),sinit(i)%ddecdp(j,par),(splus(i)%ra(j)-sinit(i)%ra(j))/eps,&
						&(splus(i)%dec(j)-sinit(i)%dec(j))/eps,0.5_rd*(splus(i)%ra(j)-sminus(i)%ra(j))/eps,&
						& 0.5_rd*(splus(i)%dec(j)-sminus(i)%dec(j))/eps
				end do !j
				close(60)
			end if!
			if (sinit(i)%rvb) then
				open(unit=61,file=trim(dirout)//'/'//trim(name)//'_'//trim(sinit(i)%name)//'_tpd_'//trim(num)//trim(extrv)//'_tpd',&
					&action='write',status='replace')
				do j=1,sinit(i)%nrv
					write(61,*) sinit(i)%trv(j),sinit(i)%drvdp(j,par),(splus(i)%rv(j)-sinit(i)%rv(j))/eps, &
						&0.5_rd*(splus(i)%rv(j)-sminus(i)%rv(j))/eps
				end do !j
				close(61)
			end if!
		
		end do !i
		
		! info to be used later
		!	open(unit=60,file=file,action='write',status='replace')
	end subroutine writeTest
	
end program test