#!/usr/bin/python
import numpy as np
import matplotlib.pyplot as plt
import os
import sys
from shutil import copy2, copyfile
import subprocess as sb
import math

yrAstart=1./12.
yrBstart=yrAstart+0.5

#yrAmid=0.5*(yrBstart+yrAstart)
#yrBmid=yrAmid+0.5



def getDate(fileName):
    fin = open(fileName,'r')
    inIter = False
    dateAstro = []
    dateRV    = []
    for l in fin:
        if len(l.split()) == 4 and l.split()[2]=='iteration:':
            niter = int(l.split()[3])
            print niter, ' iterations'
        elif len(l.split()) > 0 and l.split()[0]=='iteration':
            inIter=True
        elif inIter:
            if l.split()[2]=='astro':
                dateAstro.append(float(l.split()[3]))
            elif l.split()[2]=='rv':
                dateRV.append(float(l.split()[3]))
    return dateAstro,dateRV




if len (sys.argv)==2:
    inputFile=sys.argv[1]
else:
    inputFile='2stars.res'
print 'Input file: ', inputFile

dateAstro,dateRV = getDate(inputFile)
print dateAstro, dateRV
dateMin = min([min(dateAstro),min(dateRV)])
dateMax = max([max(dateAstro),max(dateRV)])

if dateMin % 1 < yrAstart : #case B
    start = dateMin // 1 - 1 +yrBstart
elif dateMin % 1 > yrBstart : #case B
        start = dateMin // 1  +yrBstart
else:
    start = dateMin // 1 + yrAstart


bins = np.arange(start,dateMax+0.5,0.5)



outH, b, patches = plt.hist([dateAstro,dateRV],bins)
nAstro = outH[0]
nRV = outH[1]
plt.gca().get_xaxis().set_major_formatter(plt.FormatStrFormatter('%.0f'))
plt.xlabel('Time [yr]')
plt.ylabel('Number of obs.')
plt.legend(['Astro','RV'])
if '_noEM' in inputFile.split('.')[0]:
    plt.title('Opt. on GR, no Ext. Mass  -- Num. of astro: '+str(int(np.sum(nAstro)))+'  Num. of RV: '+str(int(np.sum(nRV))))
elif '_EM' in inputFile.split('.')[0]:
    plt.title('Opt. on GR, with Ext. Mass  -- Num. of astro: '+str(int(np.sum(nAstro)))+'  Num. of RV: '+str(int(np.sum(nRV))))
else:
    plt.title('Num. of astro: '+str(int(np.sum(nAstro)))+'  Num. of RV: '+str(int(np.sum(nRV))))


#plt.show()
plt.xticks(range(2017,2030))
plt.xlim([2017.,math.ceil(dateMax)])
plt.savefig(inputFile.split('.')[0]+'_hist.png',transparent=False)

output = np.zeros([len(bins)-1,5])

output[:,0] = bins[0:-1]
output[:,1] = bins[1:]
output[:,2] = 0.5 * (output[:,0]+output[:,1])
output[:,3] = nAstro
output[:,4] = nRV
print output
np.savetxt(inputFile.split('.')[0]+'.hist',output)

